View Issue Details

IDProjectCategoryView StatusLast Update
0000780bareos-core[All Projects] directorpublic2017-06-08 12:46
Reporterbruno.crespoAssigned Tojoergs 
PrioritynormalSeveritymajorReproducibilityalways
Status closedResolutionfixed 
PlatformLinuxOSCentOSOS Version7
Product Version16.2.4 
Fixed in Version16.2.5 
Summary0000780: Reload configuration error prevents bconsole connecting anymore
DescriptionAfter a reload configuration error, bconsole can't connect anymore. Director continues running, it schedules jobs and the connected bconsoles continue working, but you can't make new connections anymore.

SOMETIMES you could connect but you couldn't increase the number of running bconsoles, let me explain:

- you have one bconsole running and trigger the reload error.
- you try to open a new bconsole: connection hangs
- you close the first bconsole and after that you could open a new bconsole connection.
- but if you try to open a second bconsole it fails.

Anyway after several reload errors it's imposible to connect anymore.

BTW, when this happens is impossible to make "service bareos-dir stop", it hangs and you need to kill the director.
Steps To Reproduce[root@obelix ~]# bconsole
Connecting to Director obelix.trustserver.net:9101
1000 OK: obelix-dir Version: 16.2.4 (01 July 2016)
Enter a period to cancel a command.
*reload
failed to reload
You have messages.
*mes
09-feb 13:06 obelix-dir: ERROR in res.c:531 Config error: Could not find config resource "UnixRoot2" referenced on line 3: JobDefs = "UnixRoot2"

            : line 3, col 22 of file /etc/bareos/bareos-dir.d/job/Pi3Root.conf
        JobDefs = "UnixRoot2"

09-feb 13:06 obelix-dir JobId 0: Error: "fileset" directive in Job "Pi3Root" resource is required, but not found.
09-feb 13:06 obelix-dir JobId 0: Error: Please correct the configuration in /etc/bareos/bareos-dir.d/*/*.conf
09-feb 13:06 obelix-dir JobId 0: Error: Resetting to previous configuration.
*quit
[root@obelix ~]#
[root@obelix ~]#
[root@obelix ~]# bconsole
Connecting to Director obelix.trustserver.net:9101

And it hangs until timeout.

Additional InformationVerified in Centos 7 and Fedora 24
TagsNo tags attached.
bareos-master: impactyes
bareos-master: actionfixed
bareos-19.2: impact
bareos-19.2: action
bareos-18.2: impact
bareos-18.2: action
bareos-17.2: impact
bareos-17.2: action
bareos-16.2: impactyes
bareos-16.2: actionfixed
bareos-15.2: impact
bareos-15.2: action
bareos-14.2: impact
bareos-14.2: action
bareos-13.2: impact
bareos-13.2: action
bareos-12.4: impact
bareos-12.4: action

Relationships

related to 0000750 closed Trying to reload the Director configuration after adding a second director resource leaves the Director in an invalid state 
child of 0000734 closedstephand Release bareos-16.2.5 

Activities

joergs

joergs

2017-03-03 23:11

developer   ~0002596

Fix committed to bareos bareos-16.2 branch with changesetid 6881.

Related Changesets

bareos: bareos-16.2 14a0e1e4

2017-02-16 11:25:44

joergs

Ported: N/A

Details Diff
Fix bareos-dir reload problems

This commit fixes two problems:
- when trying to load an invalid configuration, resources are not
unlocked properly in all cases.
- not all configuration errors have been detected as such by the reload
command.

Fixes 0000750: Trying to reload the Director configuration after adding a
second director resource leaves the Director in an invalid state
Fixes 0000780: Reload configuration error prevents bconsole connecting anymore
Affected Issues
0000750, 0000780
mod - src/dird/dird.c Diff File
mod - src/dird/ua_cmds.c Diff File
mod - src/dird/ua_configure.c Diff File
mod - src/lib/lex.c Diff File
mod - src/lib/protos.h Diff File
mod - src/lib/res.c Diff File

Issue History

Date Modified Username Field Change
2017-02-09 13:21 bruno.crespo New Issue
2017-02-09 14:41 joergs Assigned To => joergs
2017-02-09 14:41 joergs Status new => assigned
2017-02-09 14:44 joergs Relationship added related to 0000750
2017-02-16 11:29 joergs Relationship added child of 0000734
2017-02-16 11:29 joergs bareos-master: impact => yes
2017-02-16 11:29 joergs bareos-master: action => fixed
2017-02-16 11:29 joergs bareos-16.2: impact => yes
2017-02-16 11:29 joergs bareos-16.2: action => fixed
2017-02-16 11:29 joergs Fixed in Version => 16.2.5
2017-03-03 23:11 joergs Changeset attached => bareos bareos-16.2 14a0e1e4
2017-03-03 23:11 joergs Note Added: 0002596
2017-03-03 23:11 joergs Status assigned => resolved
2017-03-03 23:11 joergs Resolution open => fixed
2017-06-08 12:46 joergs Status resolved => closed